{************************************************}
{                                                }
{   Extended visual components                   }
{                                                }
{   Turbo Pascal 7                               }
{   FreePacal                                    }
{   Delphi 2 - 5                                 }
{   Virtual Pascal 2.1                           }
{                                                }
{   Copyright (c) 1995-2000 by Alexs             }
{                                                }
{************************************************}

{$IFDEF VER70}
{$O+}
{$ENDIF}

{$I Define.inc}

unit AddCntrl;
interface
uses Objects, Drivers, Views, Dialogs, Validate, Clases, Ext_Dos, Ext_Type,
     Register;

const
  CLockUpUnputLine = #19#19#20#21#22#23;
  CCalenPanel      = #26#27#28#29;

type
  PInputLineUC = ^TInputLineUC;
  TInputLineUC = object(TInputLine)
    constructor Init(var Bounds: TRect; AMaxLen: Integer);
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

type
  PInputLineLC = ^TInputLineLC;
  TInputLineLC = object(TInputLine)
    constructor Init(var Bounds: TRect; AMaxLen: Integer);
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

type
  PInputSegOfs = ^TInputSegOfs;
  TInputSegOfs = object(TInputLine)
    constructor Init(var Bounds: TRect; AMaxLen: Integer);
    function  DataSize:word;virtual;
    function ValidPointer(P:Pointer):boolean;
    procedure GetData(var Rec);virtual;
    procedure SetData(var Rec);virtual;
    function Valid(Command:word):boolean;virtual;
  end;

type
  PInputLinePS = ^TInputLinePS;
  TInputLinePS = object(TInputLine)
    PassChar:Char;
    constructor Init(var Bounds:TRect; AMaxLen:Integer; APassChar:Char);
    procedure Draw;virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
  end;

type
  PRangeILine = ^TRangeILine;
  TRangeILine = object(TInputLine)
    Min:Longint;
    Max:Longint;
    constructor Init( var Bounds:TRect; AMin,AMax:LongInt);
    constructor Load(var S:TStream);
    function Valid(Command: Word): Boolean; virtual;
    procedure Store(var S:TStream);
    procedure GetData(var Rec);virtual;
    procedure SetData(var Rec);virtual;
    function  DataSize:word;virtual;
  end;

type
  PFilterInput = ^TFilterInput;
  TFilterInput = object(TInputLine)
    Chars: TCharSet;
    constructor Init(var Bounds:TRect; AMaxLen:Integer; AChars:TCHarSet);
    procedure HandleEvent(var Event:TEvent);virtual;
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    procedure SetChars( AChars:TCHarSet);
  end;

  { TColorText }

  PColorText = ^TColorText;
  TColorText = object(TView)
    Color: Byte;
    Text: PString;
    constructor Init(var Bounds: TRect; AText: String; AColor:Byte);
    constructor Load(var S: TStream);
    destructor Done; virtual;
    procedure Draw; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure SetColor(var AColor: Byte); virtual;
    procedure Store(var S: TStream);
  end;

type
  PLockUpBox = ^TLockUpBox;
  TLockUpBox = object(TDialog)
    Viewer: PView;
    constructor Init(var Bounds: TRect; Info:Pointer);
    function GetSelection: String; virtual;
    procedure InitViewer(Info:Pointer); virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
  end;

type
  PLockUpInputLine = ^TLockUpInputLine;
  TLockUpInputLine = object(TInputLine)
    List:PStringCollection;
    constructor Init(var Bounds: TRect; AItem:PSItem);
    constructor Load(var S:TStream);
    procedure Store(var S:TStream);
    destructor Done;virtual;
    procedure SetData(var Rec);virtual;
    procedure GetData(var Rec);virtual;
    function  DataSize:word;virtual;
    function Valid(Command: Word): Boolean; virtual;
    procedure Draw;virtual;
    function GetPalette: PPalette; virtual;
    procedure InitLockUpWindow; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
  private
    procedure DoFindWord;virtual;
    function FindCurText(var Pos:integer):boolean;
  end;

type
  POkListBox = ^TOkListBox;
  TOkListBox = object(TListBox)
    constructor Init(var Bounds: TRect; ANumCols: Word;
                                 AScrollBar:PScrollBar);
    procedure SelectItem(Item: Integer); virtual;
  end;


type
   PCalenPanel = ^TCalenPanel;
   TCalenPanel = object(TView)
     Now,
     Date:TDateTime;
     EndState: Word;
     constructor Init(var Bounds: TRect);
     constructor Load(var S:TStream);
     procedure Store(var S:TStream);
     procedure Draw;virtual;
     function GetPalette: PPalette; virtual;
     procedure HandleEvent(var Event:TEvent);virtual;
     procedure DeyUp;
     procedure DeyDown;
     procedure DeyLeft;
     procedure DeyRight;
     procedure MonthUp;
     procedure MonthDown;
     function DataSize:word;virtual;
     procedure GetData(var Rec);virtual;
     procedure SetData(var Rec);virtual;
     function Execute: Word;virtual;
     procedure EndModal(Command: Word); virtual;
   end;

type
   PDateEdit = ^TDateEdit;
   TDateEdit = object(TInputLine)
      DisplayFormat:PString;
      constructor Init(var Bounds: TRect);
      constructor Load(var S:TStream);
      procedure Store(var S:TStream);
      function DataSize:word;virtual;
      procedure SetData(var Rec); virtual;
      procedure GetData(var Rec); virtual;
      function Valid(Command: Word): Boolean; virtual;
      procedure Draw;virtual;
      function GetPalette: PPalette;virtual;
      procedure HandleEvent(var Event:TEvent);virtual;
      function CurDate:TDateTime;
   end;

type
  PLargeScrollBar = ^TLargeScrollBar;
  TLargeScrollBar = object(TView)
    Value: Longint;
    Min: Longint;
    Max: Longint;
    PgStep: Longint;
    ArStep: Longint;
    constructor Init(var Bounds: TRect);
    constructor Load(var S: TStream);
    procedure Draw; virtual;
    function GetPalette: PPalette; virtual;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure ScrollDraw; virtual;
    function ScrollStep(Part: Longint): Longint;
    procedure SetParams(AValue, AMin, AMax, APgStep, AArStep: Longint);
    procedure SetRange(AMin, AMax: Longint);
    procedure SetStep(APgStep, AArStep: Longint);
    procedure SetValue(AValue: Longint);
    procedure Store(var S: TStream);
  private
    Chars: TScrollChars;
    procedure DrawPos(Pos: Longint);
    function GetPos: Longint;
    function GetSize: Longint;
  end;

{$IFNDEF DELPHI32}
const
  RInputLineUC: TStreamRec = (
     ObjType: rcInputLineUC;
     VmtLink: Ofs(TypeOf(TInputLineUC)^);
     Load:    @TInputLineUC.Load;
     Store:   @TInputLineUC.Store
  );

const
  RInputLineLC: TStreamRec = (
     ObjType: rcInputLineLC;
     VmtLink: Ofs(TypeOf(TInputLineLC)^);
     Load:    @TInputLineLC.Load;
     Store:   @TInputLineLC.Store
  );

const
  RInputLinePS: TStreamRec = (
     ObjType: rcInputLinePS;
     VmtLink: Ofs(TypeOf(TInputLinePS)^);
     Load:    @TInputLinePS.Load;
     Store:   @TInputLinePS.Store
  );

const
  RFilterInput: TStreamRec = (
     ObjType: rcFilterInput;
     VmtLink: Ofs(TypeOf(TFilterInput)^);
     Load:    @TFilterInput.Load;
     Store:   @TFilterInput.Store
  );

const
  RColorText: TStreamRec = (
     ObjType: rcColorText;
     VmtLink: Ofs(TypeOf(TColorText)^);
     Load:    @TColorText.Load;
     Store:   @TColorText.Store
  );
const
  RRangeILine: TStreamRec = (
     ObjType: rcRangeILine;
     VmtLink: Ofs(TypeOf(TRangeILine)^);
     Load:    @TRangeILine.Load;
     Store:   @TRangeILine.Store
  );
const
  RInputSegOfs: TStreamRec = (
     ObjType: rcInputSegOfs;
     VmtLink: Ofs(TypeOf(TInputSegOfs)^);
     Load:    @TInputSegOfs.Load;
     Store:   @TInputSegOfs.Store
  );
const
  RLockUpBox: TStreamRec = (
     ObjType: rcLockUpBox;
     VmtLink: Ofs(TypeOf(TLockUpBox)^);
     Load:    @TLockUpBox.Load;
     Store:   @TLockUpBox.Store
  );
const
  RLockUpInputLine: TStreamRec = (
     ObjType: rcLockUpInputLine;
     VmtLink: Ofs(TypeOf(TLockUpInputLine)^);
     Load:    @TLockUpInputLine.Load;
     Store:   @TLockUpInputLine.Store
  );
const
  ROkListBox: TStreamRec = (
     ObjType: rcOkListBox;
     VmtLink: Ofs(TypeOf(TOkListBox)^);
     Load:    @TOkListBox.Load;
     Store:   @TOkListBox.Store
  );
const
  RCalenPanel: TStreamRec = (
     ObjType: rcCalenPanel;
     VmtLink: Ofs(TypeOf(TCalenPanel)^);
     Load:    @TCalenPanel.Load;
     Store:   @TCalenPanel.Store
  );

const
  RDateEdit: TStreamRec = (
     ObjType: rcDateEdit;
     VmtLink: Ofs(TypeOf(TDateEdit)^);
     Load:    @TDateEdit.Load;
     Store:   @TDateEdit.Store
  );

const
  RLargeScrollBar: TStreamRec = (
     ObjType: rcLargeScrollBar;
     VmtLink: Ofs(TypeOf(TLargeScrollBar)^);
     Load:    @TLargeScrollBar.Load;
     Store:   @TLargeScrollBar.Store
  );
{$ENDIF}

procedure RegisterAddCntrl;
function InitCalendarPicWindow(var Bounds: TRect; View:PView; D:TDateTime): PCalenPanel;

{const
  PalDateEdit: String[Length(CLockUpUnputLine)] = CLockUpUnputLine;}

implementation
uses Ext_Str, Ext_Math, MsgBox, App, StdDlg, Ext_Sys;

    {TInputLineUC}
constructor TInputLineUC.Init(var Bounds: TRect; AMaxLen: Integer);
begin
  inherited Init( Bounds, AMaxLen);
  {$IFNDEF VIRTUALPASCAL}
  ComponentType:=ctInputLineUC;
  {$ENDIF}
end;

procedure TInputLineUC.HandleEvent(var Event:TEvent);
begin
  if (Event.What = evKeyDown) then
      Event.CharCode:= ChUpCase( Event.CharCode);
  inherited HandleEvent(Event);
end;


   {TInputLinePS}

constructor TInputLinePS.Init(var Bounds:TRect; AMaxLen:Integer; APassChar:Char);
begin
  inherited init( Bounds, AMaxLen);
  PassChar:=APassChar;
  {$IFNDEF VIRTUALPASCAL}
  ComponentType:=ctInputLinePS;
  {$ENDIF}
end;

constructor TInputLinePS.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read( PassChar, SizeOf( Char));
end;

procedure TInputLinePS.Store(var S:TStream);
begin
  inherited Store(s);
  S.Write( PassChar, SizeOf( Char));
end;

procedure TInputLinePS.Draw;
var
  Orid: string;
begin
  if (Length(Data^)>0) then
  begin
    Orid:=Data^;
    Data^:= DupChar( PassChar, Length(Data^));
    inherited Draw;
    Data^:=Orid;
  end
  else
    inherited Draw;
end;

    {TInputLineLC}
constructor TInputLineLC.Init(var Bounds: TRect; AMaxLen: Integer);
begin
  inherited Init( Bounds, AMaxLen);
  {$IFNDEF VIRTUALPASCAL}
  ComponentType:=ctInputLineLC;
  {$ENDIF}
end;

procedure TInputLineLC.HandleEvent(var Event:TEvent);
begin
  if (Event.What = evKeyDown) then
      Event.CharCode:= ChLoCase( Event.CharCode);
  inherited HandleEvent(Event);
end;

  {TFilterInput}

constructor TFilterInput.Init(var Bounds:TRect; AMaxLen:Integer; AChars:TCHarSet);
begin
  inherited init( Bounds, AMaxLen);
  Chars:=AChars;
  ComponentType:=ctFilterInput;
end;

procedure TFilterInput.HandleEvent(var Event:TEvent);
begin
  if (Event.What = evKeyDown) then
  begin
    if (Event.CharCode<>#0) and (Event.CharCode>#$20) then
    if not (Event.CharCode in Chars) then
    begin
       ClearEvent(Event);
       exit;
    end;
  end;
  inherited HandleEvent(Event);
end;

constructor TFilterInput.Load(var S:TStream);
begin
  inherited Load(s);
  S.Read( Chars, SizeOf( TCharSet));
end;

procedure TFilterInput.Store(var S:TStream);
begin
  inherited Store(s);
  S.Write( Chars, SizeOf( TCharSet));
end;

procedure TFilterInput.SetChars( AChars:TCHarSet);
begin
  Chars:=AChars;
end;

  { TColorText }
constructor TColorText.Init(var Bounds: TRect; AText: String; AColor:Byte);
begin
  TView.Init(Bounds);
  EventMask := EventMask or evBroadcast;
  Text := NewStr(AText);
  Color := AColor;
  ComponentType:=ctColorText;
end;

constructor TColorText.Load(var S: TStream);
begin
  TView.Load(S);
  Text := S.ReadStr;
  S.Read(Color, SizeOf(Byte));
end;

destructor TColorText.Done;
begin
  DisposeStr(Text);
  TView.Done;
end;

procedure TColorText.Draw;
var
  B: TDrawBuffer;
  I: Integer;
  C: Byte;
begin
  C := Color;
  if C = 0 then C := ErrorAttr;
  for I := 0 to Size.X div Length(Text^) do
    MoveStr(B[I*Length(Text^)], Text^, C);
  WriteLine(0, 0, Size.X, Size.Y, B);
end;

procedure TColorText.HandleEvent(var Event: TEvent);
begin
  TView.HandleEvent(Event);
  if (Event.What = evBroadcast) and (Event.Command = cmColorTextChanged) then
  begin
      Color := Event.InfoByte;
      DrawView;
  end;
end;

procedure TColorText.SetColor(var AColor: Byte);
begin
  Color := AColor;
  DrawView;
end;

procedure TColorText.Store(var S: TStream);
begin
  TView.Store(S);
  S.WriteStr(Text);
  S.Write(Color, SizeOf(Byte));
end;

 { TRangeILine }
constructor TRangeILine.Init( var Bounds:TRect; AMin,AMax:LongInt);
begin
  inherited Init( Bounds, 255);
  Min:=AMin;
  Max:=AMax;
  Options:= Options or ofValidate;
  ComponentType:=ctRangeILine;
end;

constructor TRangeILine.Load(var S:TStream);
begin
  inherited Load(S);
  S.Read( Min, SizeOf(LongInt)*2);
end;

procedure TRangeILine.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write( Min, SizeOf(LongInt)*2);
end;

procedure TRangeILine.GetData(var Rec);
var
  V:Longint;
  Code: Integer;
begin
  Val( Data^, V, Code);
  Longint(Rec):=V;
end;

procedure TRangeILine.SetData(var Rec);
{//var
//  S:string;}
begin
{//  S:=IntToStr(Longint(Rec));
//  Move(S[0], Data^[0], Byte(S[0])+1);}
  Data^:=IntToStr(Longint(Rec));
  SelectAll(True);
end;

function TRangeILine.DataSize:word;
begin
  DataSize:=SizeOf(Longint);
end;

function TRangeILine.Valid(Command: Word): Boolean;
var
  V:Longint;
  Code: Integer;
  Param:array [1..2] of Longint;
begin
  Valid := inherited Valid(Command);
  if (Command = cmValid) then exit;
  Code:=0;
  if Data^<>'' then Val( Data^, V, Code) else V:=0;
  if (Command = cmOk) or (Command = cmReleasedFocus) then
      if (Code = 0) and (V>=Min) and (V<=Max) then Valid:=true
      else
      begin
        Valid:=false;
        Param[1]:=min;
        Param[2]:=max;
        ErrorMessage(mcInvalidValue, @Param, mfError+mfOkButton);
        SelectAll(true);
        Select;
      end;
end;

{TInputSegOfs}
constructor TInputSegOfs.Init(var Bounds: TRect; AMaxLen: Integer);
begin
  inherited Init( Bounds, AMaxLen);
  ComponentType:=ctInputSegOfs;
end;

function TInputSegOfs.DataSize:word;
begin
  DataSize:=SizeOf(Pointer);
end;

function TInputSegOfs.ValidPointer(P:Pointer):boolean;
var
  I,S,O:Integer;
begin
  ValidPointer:=false;
  {$IFDEF VER70}
  i:=pos(':',Data^);
  if i=0 then exit;

  val('$'+Copy(Data^,1,i-1),PtrRec(P^).Seg,S);
  val('$'+Copy(Data^,i+1,255),PtrRec(P^).Ofs,O);
  ValidPointer:= (O+S) = 0;
  {$ENDIF}
end;

procedure TInputSegOfs.GetData(var Rec);
begin
  ValidPointer(@REc);
end;

procedure TInputSegOfs.SetData(var Rec);
var
  Pm:array[0..1] of longint;
begin
{  Pm[0]:=PtrRec(Rec).Seg;
  Pm[1]:=PtrRec(Rec).Ofs;
  FormatStr(Data^,'%04x:%04x',Pm);}
end;

function TInputSegOfs.Valid(Command:word):boolean;
var
  P:Pointer;
begin
  Valid:=true;
  if (Command=cmCancel) or (Command=cmValid) then Exit;
  if ValidPointer(@P) then Exit;
  ErrorMessage( mcInvalidAdres, nil, mfError+mfOkButton);
  SelectAll(True);
  Valid:=false;
end;

{ TLockUpBox }
constructor TLockUpBox.Init(var Bounds: TRect; Info:Pointer);
begin
  inherited Init(Bounds, '');
  Flags := wfClose;
  InitViewer(Info);
  Palette:=dpBlueDialog;
  ComponentType:=ctLockUpBox;
end;


function TLockUpBox.GetSelection: String;
begin
  GetSelection := PListBox(Viewer)^.GetText(PListBox(Viewer)^.Focused,255);
end;

procedure TLockUpBox.InitViewer(Info:Pointer);
var
  R: TRect;
begin
  GetExtent(R);
  R.Grow(-1,-1);
  Viewer := New(PListBox, Init(R, 1,
    StandardScrollBar(sbVertical + sbHandleKeyboard)));
  Insert(Viewer);
end;

procedure TLockUpBox.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  case Event.What of
    evBroadcast:
    case Event.Command of
      cmDefault:EndModal(cmOk);
      cmListItemSelected:
             if Event.InfoPtr=Viewer then EndModal(cmOk)
             else exit;
    else
      exit;
    end;
    evKeyDown:
    case Event.KeyCode of
      kbEnter: EndModal(cmOk);
      kbEsc: EndModal(cmCancel)
    else
      exit;
    end;
    evCommand:
    case Event.Command of
        cmOk, cmCancel, cmYes, cmNo:EndModal(Event.Command);
    else
      exit;
    end;
  else
    exit;
  end;
  ClearEvent(Event);
end;

{ TLockUpInputLine }
constructor TLockUpInputLine.Init(var Bounds: TRect; AItem:PSItem);
var I:PSItem;
begin
  inherited Init( Bounds, 255);
  List:=New(PStringCollection, Init(10,5));
  while AItem<>nil do
  begin
    I:=AItem^.Next;
    List^.AtInsert(List^.Count, AItem^.Value);
    Dispose(AItem);
    AItem:=I;
  end;
  ComponentType:=ctLockUpInputLine;
end;

destructor TLockUpInputLine.Done;
begin
  Dispose(List, Done);
  inherited Done;
end;

constructor TLockUpInputLine.Load(var S:TStream);
begin
  inherited Load(S);
  List:=PStringCollection(S.Get);
end;

procedure TLockUpInputLine.Store(var S:TStream);
begin
  inherited Store(S);
  S.Put(List);
end;

function TLockUpInputLine.FindCurText(var Pos:Integer):boolean;
var Temp:string;
    j:integer;
begin
  FindCurText:=false;
  Pos:=0;
  if (List<>nil) and (Data^<>'') then
  begin
    Temp:=stUpCase(Data^);
    for j:=0 to List^.Count-1 do
      if stUpCase(PString(List^.At(j))^)=Temp then
      begin
        FindCurText:=true;
        Pos:=j;
        break;
      end;
  end;
end;

function TLockUpInputLine.Valid(Command: Word): Boolean;
var B:boolean;
    i:integer;
begin
  Valid:=inherited Valid(Command);
  if (Command<>cmCancel) and (Command<>cmValid) then
  begin
    if Data^='' then B:=true else B:=FindCurText(I);
    Valid:=B;
    if not B then
    begin
      Select;
      ErrorMessage(mcNotInListParam, @Data, mfError+mfOkButton);
    end;
  end;
end;

procedure TLockUpInputLine.SetData(var Rec);
var
  L:longint absolute Rec;
  S:string;
begin
  if (L>-1) and (L<List^.Count) then
  begin
    S:=PString(List^.At(l))^;
    SetLength(S,Min(MaxLen, Length(S)));
    Data^:=S;
    SelectAll(True);
  end;
end;

procedure TLockUpInputLine.GetData(var Rec);
var
  L:longint absolute Rec;
  I:integer absolute Rec;
begin
  L:=0;
  if (List=nil) or not FindCurText(I) then L:=-1;
end;

function TLockUpInputLine.DataSize:word;
begin
  DataSize:=SizeOf(Longint);
end;

procedure TLockUpInputLine.Draw;
var
  B: TDrawBuffer;
begin
  inherited Draw;
  MoveCStr(B, #222'~'#25'~'#221, GetColor($0506));
  WriteLine(Size.X-3, 0, Size.X, Size.Y, B);
end;

function TLockUpInputLine.GetPalette: PPalette;
const
  P: String[Length(CLockUpUnputLine)] = CLockUpUnputLine;
begin
  GetPalette := @P;
end;

procedure TLockUpInputLine.InitLockUpWindow;
var
  P: PLockUpBox;
  Rec:TListBoxRec;
  R,RR:TRect;
  TP:TPoint;
  S:String;
  L:longint;
begin
  GetBounds(R);
  Owner^.MakeGlobal(R.A, TP);
  R.Assign(TP.X,TP.Y-1, TP.X+Size.X, TP.Y+7);
  Application^.GetExtent(RR);
  R.Intersect(RR);
  if R.B.Y-R.A.Y<5 then
    if R.B.Y=RR.B.Y then R.A.Y:=R.B.Y-7 else
    if R.A.Y=RR.A.Y then R.B.Y:=R.A.Y+7;
  P := New(PLockUpBox, Init(R, nil));
  P^.HelpCtx := HelpCtx;
  Rec.List:=List;
{$ifdef ver70}
  FindCurText(integer(Rec.Selection));
{$else}
  FindCurText(Rec.Selection);
{$ENDIF}
  P^.SetData(Rec);
  if Application^.ExecView(P) = cmOk then
  begin
    S := P^.GetSelection;
    SetLength(S, Min(MaxLen, Length(S)));
    Data^ := S;
    SelectAll(True);
    DrawView;
    Message(Owner, evBroadcast, cmViewChanged, @Self);
  end;
  P^.Free;
end;

procedure TLockUpInputLine.HandleEvent(var Event: TEvent);
var
  D:TPoint;
  L:Boolean;
begin
  if (Event.What = evMouseDown) then
  begin
     MakeLocal(Event.Where, D);
     if ((D.X>Size.X-3) and (D.X<Size.X-1)) then
     begin
       InitLockUpWindow;
       ClearEvent(Event);
     end;
  end;
  L:= (Event.What = evKeyDown) and (Event.CharCode in WordChars);
  inherited HandleEvent(Event);
  if (Event.What = evKeyDown) then
    if (CtrlToArrow(Event.KeyCode)=kbDown) then
    begin
       InitLockUpWindow;
       ClearEvent(Event);
    end
    else
  else
  if L then DoFindWord;
end;

procedure TLockUpInputLine.DoFindWord;
var P:PString;
    S:String;
    I:integer;
begin
  S:=stUpCase(Data^);
  P:=nil;
  for i:=0 to List^.Count-1 do
    if stUpCase(Copy(PString(List^.At(i))^,1,Length(S)))=S then
    begin
      P:=List^.At(i);
      break;
    end;
  if P<>nil then
  begin
     S:=Data^+Copy(P^, Length(Data^)+1, 255);
     SelStart := Length(Data^);
     SelEnd := Length(S);
     Data^:=S;
     DrawView;
  end;
end;

{ TOkListBox }
constructor TOkListBox.Init(var Bounds: TRect; ANumCols: Word; AScrollBar:PScrollBar);
begin
  inherited Init( Bounds, ANumCols, AScrollBar);
  ComponentType:=ctOkListBox;
end;

procedure TOkListBox.SelectItem(Item: Integer);
var
  E: TEvent;
begin
  inherited SelectItem(Item);
  with E do
  begin
    What := evCommand;
    Command := cmOk;
    InfoPtr := nil;
  end;
  PutEvent(E);
end;


{TCalenPanel}
function Num2Str(I: Integer): String;
var
  S:String;
begin
  Str(i:2, S);
  Num2Str := S;
end;

constructor TCalenPanel.Init(var Bounds: TRect);
begin
  inherited Init( Bounds);
  Now:=Ext_Dos.Now;
  Date:=Now;
  Options := Options or (ofFirstClick + ofSelectable);
  EventMask := EventMask or evBroadcast;
  ComponentType:=ctCalenPanel;
end;

procedure TCalenPanel.Draw;
var
  S:string;
  B: TDrawBuffer;
  Rec:array [1..2] of longint;
  Days,DayOf,i,j, CurDays:integer;
  Color:word;
  Year, Month, Day: Word;
  nYear,nMonth,nDay: Word;
begin
  Color:=GetColor(1);
  DecodeDate(Date,Year, Month, Day);
  DecodeDate(Now,nYear,nMonth,nDay);
  Days := DayInMonth(Month, Year);
  Rec[2]:=Year;
  Rec[1]:=Longint(@(LongMonthNames[Month]));
  FormatStr(S,' '#17' %-9s'#16#32#32#30'%5d '#31,Rec);
  MoveChar(B, #32, GetColor(1), Size.X);
  MoveStr(B, S, GetColor(4));
  WriteLine(0, 0, Size.X, 1, B);
  DayOf := DayOfWeek(1, Month, Year);
  MoveChar(B, ' ', Color, Size.X);
  MoveStr(B[2], ShortNameDayOfW, Color);
  WriteLine(0, 1, Size.X, 1, B);
  if DayOf = 0 then CurDays:=-5
  else CurDays := 2 - DayOf;
  for i := 1 to 6 do
  begin
    MoveChar(B, ' ', Color, Size.X);
    for j := 0 to 6 do
    begin
      if (CurDays < 1) or (CurDays > Days) then MoveStr(B[j * 3+2], '   ', Color)
      else
        { if it is the current day }
        if (CurDays = Day) then MoveStr(B[j * 3+2], Num2Str(CurDays), GetColor(2))
        else if (Year = nYear) and (Month = nMonth) and
           (CurDays = nDay) then
          MoveStr(B[j * 3+2], Num2Str(CurDays), GetColor(3))
        else
          MoveStr(B[j * 3+2], Num2Str(CurDays), Color);
      Inc(CurDays);
    end;
    WriteLine(0, i + 1, Size.X, 1, B);
  end;
end;

function TCalenPanel.GetPalette: PPalette;
const
  P: String[Length(CCalenPanel)] = CCalenPanel;
begin
  GetPalette := @P;
end;

procedure TCalenPanel.DeyUp;
begin
  Date:=Date - 7;
end;

procedure TCalenPanel.DeyDown;
begin
  Date:=Date+7;
end;

procedure TCalenPanel.DeyLeft;
begin
  Date:=Date-1;
end;

procedure TCalenPanel.DeyRight;
begin
  Date:=Date+1;
end;

procedure TCalenPanel.MonthDown;
begin
  Date:=IncMonth(Date,-1);
end;

procedure TCalenPanel.MonthUp;
begin
  Date:=IncMonth(Date,1);
end;

procedure TCalenPanel.HandleEvent(var Event:TEvent);
var
  Point:TPoint;

procedure XYtoDate;
var
  X,Y,i,j,CurDays,DayOf:integer;
  Month, Year, Day:word;
begin
  Y:=Point.Y-2;
  X:=(Point.X-2) div 3;
  DecodeDate(Date,Year, Month, Day);
  DayOf := DayOfWeek(1, Month, Year);
  if DayOf = 0 then CurDays:=-5
  else CurDays := 2 - DayOf;
  for i := 0 to 5 do
    for j := 0 to 6 do
    begin
      if (I=Y) and (j=x) then
      begin
        Day:=CurDays;
        if CurDays<1 then Day:=1
        else if CurDays>DayInMonth(Month, Year) then
                Day:=DayInMonth(Month, Year)
        else Day:=CurDays;
        exit;
        Date:=EncodeDate(Year, Month, Day);
      end;
      Inc(CurDays);
    end;
  Date:=EncodeDate(Year, Month, Day);
end;

begin
  inherited HandleEvent(Event);
  if Event.What and (evMouseDown + evMouseAuto) <> 0 then
  begin
      MakeLocal(Event.Where, Point);
      if (Point.Y = 0) then
      case Point.X of
        1:MonthDown;
        12:MonthUp;
        15:Date:=IncMonth(Date,12);
        22:Date:=IncMonth(Date,-12);
      else
          exit;
      end
      else
      if (Point.Y <> 1) then
      begin
        XYtoDate;
        if Event.Double then
        begin
          Event.What:=evCommand;
          if (Point.Y>Size.Y) or (Point.X>Size.X) or
             (Point.X<0) or (Point.Y<0) then EndModal(cmCancel)
          else  Event.Command:=cmDateSelected;
          Event.InfoPtr:=@Self;
          PutEvent(Event)
        end
      end
      else
          exit;
  end
  else
  if Event.What = evKeyDown then
    case Event.KeyCode of
      kbLeft:DeyLeft;
      kbRight:DeyRight;
      kbUp:DeyUp;
      kbDown:DeyDown;
      kbCtrlPgUp:Date:=IncMonth(Date,12);
      kbCtrlPgDn:Date:=IncMonth(Date,-12);
      kbPgUp:MonthDown;
      kbPgDn:MonthUp;
      kbEnter:begin
                   Event.What:=evCommand;
                   Event.Command:=cmDateSelected;
                   Event.InfoPtr:=@Self;
                   PutEvent(Event)
              end;
      kbESC:EndModal(cmCancel);
    else
      exit;
    end
  else
    exit;
  ClearEvent(Event);
  DrawView;
end;

function TCalenPanel.DataSize:word;
begin
  DataSize:=SizeOf(TDateTime);
end;

procedure TCalenPanel.GetData(var Rec);
begin
  Move(Date, Rec, SizeOf(TDateTime));
end;

procedure TCalenPanel.SetData(var Rec);
begin
  Move(Rec, Date, SizeOf(TDateTime));
  if Date=0 then Date:=Now;
end;

constructor TCalenPanel.Load(var S:TStream);
begin
  inherited Load(S);
  Now:=Ext_Dos.Now;
  S.Read(Date, SizeOf(TDateTime));
end;

procedure TCalenPanel.Store(var S:TStream);
begin
  inherited Store(S);
  S.Write(Date, SizeOf(TDateTime));
end;

function TCalenPanel.Execute: Word;
var
  E: TEvent;
begin
  repeat
    EndState := 0;
    repeat
      GetEvent(E);
      if (E.What=evCommand) and (E.Command=cmDateSelected) then
         EndModal(cmOk);
      HandleEvent(E);
      if E.What <> evNothing then Owner^.EventError(E);
    until EndState <> 0;
  until Valid(EndState);
  Execute := EndState;
end;

procedure TCalenPanel.EndModal(Command: Word);
begin
  if State and sfModal <> 0 then EndState := Command
  else TView.EndModal(Command);
end;

  {TDateEdit}
constructor TDateEdit.Init(var Bounds: TRect);
var D:TDateTime;
begin
  inherited Init(Bounds, 12);
  SetValidator(New(PDateValidatorEx, Init('!',true)));
  ComponentType:=ctDateEdit;
  DisplayFormat:=NewStr(ShortDateFormat);
  D:=Now;
  SetData(D);
end;

constructor TDateEdit.Load(var S:TStream);
begin
  inherited Load(S);
  DisplayFormat:=S.ReadStr;
end;

procedure TDateEdit.Store(var S:TStream);
begin
  inherited Store(S);
  S.WriteStr(DisplayFormat);
end;

function TDateEdit.DataSize:word;
begin
  DataSize:=SizeOf(TDateTime);
end;

procedure TDateEdit.SetData(var Rec);
var
  D:TDateTime absolute Rec;
  S:string;
begin
  if D<>0 then
  begin
    S:=Trim(DateToStr(D));
    Data^:=S;
    SelectAll(True);
  end;
end;

procedure TDateEdit.GetData(var Rec);
var
  D:TDateTime absolute Rec;
  S:string;
begin
  TInputLine.GetData(S);
  D:=StrToDate(S);
end;

function TDateEdit.Valid(Command: Word): Boolean;
{var D:TDateTime;}
begin
  Valid:=true;
  if not inherited Valid(Command) then
  begin
    Valid:=false;
    exit;
  end;
{  if (Command=cmOk) or (Command=cmValid) then
  if Data^<>'' then
  begin
    GetData(D);
    if D=0 then
    begin
      Select;
      Valid:=false;
      MessageBoxProc(mbpNotDate, @Data);
    end;
  end;}
end;

function TDateEdit.GetPalette: PPalette;
const
  P:string[Length(CLockUpUnputLine)] = CLockUpUnputLine;
begin
  GetPalette := @P;
end;

procedure TDateEdit.Draw;
var
  B: TDrawBuffer;
  L:integer;
  Color:word;
procedure DoOldDraw;
begin
  L:=Size.X;
  Dec(Size.X,3);
  inherited Draw;
  Size.X:=L;
end;

begin
  if (Data=nil) or (State and sfFocused<>0) then DoOldDraw
  else
  begin
    if (State and sfSelected)<>0 then DoOldDraw
    else
    begin
      Color:=GetColor(1);
      MoveChar(B, ' ', Color, Size.X);
      MoveStr(B[1], FormatDateTime(StrToDate(Data^), DisplayFormat^), Color);
      WriteLine(0, 0, Size.X-3, Size.Y, B);
    end;
  end;
  MoveCStr(B, #222'~'#25'~'#221, GetColor($0506));
  WriteLine(Size.X-3, 0, Size.X, Size.Y, B);
end;

function TDateEdit.CurDate:TDateTime;
begin
  CurDate:=StrToDate(Data^);
end;

function InitCalendarPicWindow(var Bounds: TRect; View:PView; D:TDateTime): PCalenPanel;
var
  P: PCalenPanel;
begin
  P:=New(PCalenPanel, Init( Bounds));
  if P<>nil then
  begin
    P^.SetState(sfShadow, true);
    P^.HelpCtx := View^.HelpCtx;
    P^.SetData(D);
  end;
  InitCalendarPicWindow := P;
end;

procedure TDateEdit.HandleEvent(var Event:TEvent);
var
  CalenPanel: PCalenPanel;
  Mouse: TPoint;
  R,P:TRect;
begin
  MakeLocal(Event.Where, Mouse);
  if ((Event.What = evMouseDown) and (Mouse.X>Size.X-4)) or
     ((Event.What = evKeyDown) and (CtrlToArrow(Event.KeyCode) = kbDown)) then
  begin
    GetBounds(R);
    Inc(R.A.Y); R.B.X:=R.A.X+25; R.B.Y:=R.A.Y+9;
    Owner^.GetExtent(P);
{    Application^.GetExtent(P);}
    R.Intersect(P);
    Dec(R.B.Y,1);
    if R.B.X-R.A.X<25 then R.A.X:=R.B.X-25;
    if R.B.Y-R.A.Y<9 then R.A.Y:=R.B.Y-8;
    CalenPanel := InitCalendarPicWindow(R, @Self, StrToDate(Data^));
    if CalenPanel <> nil then
    begin
      if Owner^.ExecView(CalenPanel) = cmOk then
{      if Application^.ExecView(CalenPanel) = cmOk then}
         SetData(CalenPanel^.Date);
      Select;
      Dispose(CalenPanel, Done);
    end;
    ClearEvent(Event);
    exit;
  end;
  inherited HandleEvent(Event);
end;


{ TScrollBar }

constructor TLargeScrollBar.Init(var Bounds: TRect);
begin
  TView.Init(Bounds);
  Value := 0;
  Min := 0;
  Max := 0;
  PgStep := 1;
  ArStep := 1;
  if Size.X = 1 then
  begin
    GrowMode := gfGrowLoX + gfGrowHiX + gfGrowHiY;
    Chars := VChars{$IFNDEF VER70}[true]{$ENDIF};
  end else
  begin
    GrowMode := gfGrowLoY + gfGrowHiX + gfGrowHiY;
    Chars := HChars{$IFNDEF VER70}[true]{$ENDIF};
  end;
  ComponentType:=ctScrollBar;
end;

constructor TLargeScrollBar.Load(var S: TStream);
begin
  TView.Load(S);
  S.Read(Value, SizeOf(Longint) * 5 + SizeOf(TScrollChars));
end;

procedure TLargeScrollBar.Draw;
begin
  DrawPos(GetPos);
end;

procedure TLargeScrollBar.DrawPos(Pos: Longint);
var
  S: Longint;
  B: TDrawBuffer;
begin
  S := GetSize - 1;
  MoveChar(B[0], Chars[0], GetColor(2), 1);
  if Max = Min then
    MoveChar(B[1], Chars[4], GetColor(1), S - 1)
  else
  begin
    MoveChar(B[1], Chars[2], GetColor(1), S - 1);
    MoveChar(B[Pos], Chars[3], GetColor(3), 1);
  end;
  MoveChar(B[S], Chars[1], GetColor(2), 1);
  WriteBuf(0, 0, Size.X, Size.Y, B);
end;

function TLargeScrollBar.GetPalette: PPalette;
const
  P: String[Length(CScrollBar)] = CScrollBar;
begin
  GetPalette := @P;
end;

function TLargeScrollBar.GetPos: Longint;
var R: Longint;
begin
  R := Max - Min;
  if R = 0 then
    GetPos := 1 else
    GetPos := (((Value - Min) * (GetSize - 3))+R shr 1) div R + 1;
{    LongDiv(LongMul(Value - Min, GetSize - 3) + R shr 1, R) + 1;}
end;

function TLargeScrollBar.GetSize: Longint;
var S:Longint;
begin
  if Size.X = 1 then S := Size.Y else S := Size.X;
  if S < 3 then GetSize := 3 else GetSize := S;
end;

procedure TLargeScrollBar.HandleEvent(var Event: TEvent);
var
  Tracking: Boolean;
  I, P, S, ClickPart: Longint;
  Mouse: TPoint;
  Extent: TRect;

function GetPartCode: Longint;
var Mark, Part: Longint;
begin
  Part := -1;
  if Extent.Contains(Mouse) then
  begin
    if Size.X = 1 then Mark := Mouse.Y else Mark := Mouse.X;
    if Mark = P then Part := sbIndicator else
    begin
      if Mark < 1 then Part := sbLeftArrow else
        if Mark < P then Part := sbPageLeft else
          if Mark < S then Part := sbPageRight else
            Part := sbRightArrow;
      if Size.X = 1 then Inc(Part, 4);
    end;
  end;
  GetPartCode := Part;
end;

procedure Clicked;
begin
  Message(Owner, evBroadcast, cmScrollBarClicked, @Self);
end;

begin
  TView.HandleEvent(Event);
  case Event.What of
    evMouseDown:
      begin
        Clicked;
        MakeLocal(Event.Where, Mouse);
        GetExtent(Extent);
        Extent.Grow(1, 1);
        P := GetPos;
        S := GetSize - 1;
        ClickPart := GetPartCode;
        if ClickPart <> sbIndicator then
        begin
          repeat
            MakeLocal(Event.Where, Mouse);
            if GetPartCode = ClickPart then
              SetValue(Value + ScrollStep(ClickPart));
          until not MouseEvent(Event, evMouseAuto);
        end else
        begin
          repeat
            MakeLocal(Event.Where, Mouse);
            Tracking := Extent.Contains(Mouse);
            if Tracking then
            begin
              if Size.X = 1 then I := Mouse.Y else I := Mouse.X;
              if I <= 0 then I := 1;
              if I >= S then I := S - 1;
            end else I := GetPos;
            if I <> P then
            begin
              DrawPos(I);
              P := I;
            end;
          until not MouseEvent(Event, evMouseMove);
          if Tracking and (S > 2) then
          begin
            Dec(S, 2);
            {SetValue(LongDiv(LongMul(P - 1, Max - Min) + S shr 1, S) + Min);}
          end;
        end;
        ClearEvent(Event);
      end;
    evKeyDown:
      if State and sfVisible <> 0 then
      begin
        ClickPart := sbIndicator;
        if Size.Y = 1 then
          case CtrlToArrow(Event.KeyCode) of
            kbLeft: ClickPart := sbLeftArrow;
            kbRight: ClickPart := sbRightArrow;
            kbCtrlLeft: ClickPart := sbPageLeft;
            kbCtrlRight: ClickPart := sbPageRight;
            kbHome: I := Min;
            kbEnd: I := Max;
          else
            Exit;
          end
        else
          case CtrlToArrow(Event.KeyCode) of
            kbUp: ClickPart := sbUpArrow;
            kbDown: ClickPart := sbDownArrow;
            kbPgUp: ClickPart := sbPageUp;
            kbPgDn: ClickPart := sbPageDown;
            kbCtrlPgUp: I := Min;
            kbCtrlPgDn: I := Max;
          else
            Exit;
          end;
        Clicked;
        if ClickPart <> sbIndicator then I := Value + ScrollStep(ClickPart);
        SetValue(I);
        ClearEvent(Event);
      end;
  end;
end;

procedure TLargeScrollBar.ScrollDraw;
begin
  Message(Owner, evBroadcast, cmScrollBarChanged, @Self);
end;

function TLargeScrollBar.ScrollStep(Part: Longint): Longint;
var Step:Longint;
begin
  if Part and 2 = 0 then Step := ArStep else Step := PgStep;
  if Part and 1 = 0 then ScrollStep := -Step else ScrollStep := Step;
end;

procedure TLargeScrollBar.SetParams(AValue, AMin, AMax, APgStep,
  AArStep: Longint);
var SValue:Longint;
begin
  if AMax < AMin then AMax := AMin;
  if AValue < AMin then AValue := AMin;
  if AValue > AMax then AValue := AMax;
  SValue := Value;
  if (SValue <> AValue) or (Min <> AMin) or (Max <> AMax) then
  begin
    Value := AValue;
    Min := AMin;
    Max := AMax;
    DrawView;
    if SValue <> AValue then ScrollDraw;
  end;
  PgStep := APgStep;
  ArStep := AArStep;
end;

procedure TLargeScrollBar.SetRange(AMin, AMax:Longint);
begin
  SetParams(Value, AMin, AMax, PgStep, ArStep);
end;

procedure TLargeScrollBar.SetStep(APgStep, AArStep:Longint);
begin
  SetParams(Value, Min, Max, APgStep, AArStep);
end;

procedure TLargeScrollBar.SetValue(AValue:Longint);
begin
  SetParams(AValue, Min, Max, PgStep, ArStep);
end;

procedure TLargeScrollBar.Store(var S: TStream);
begin
  TView.Store(S);
  S.Write(Value, SizeOf(Longint) * 5 + SizeOf(TScrollChars));
end;


procedure RegisterAddCntrl;
begin
{$IFNDEF DELPHI32}
  RegisterType(RInputLineUC);
  RegisterType(RInputLineLC);
  RegisterType(RInputLinePS);
  RegisterType(RFilterInput);
  RegisterType(RColorText);
  RegisterType(RRangeILine);
  RegisterType(RInputSegOfs);
  RegisterType(RLockUpBox);
  RegisterType(RLockUpInputLine);
  RegisterType(RCalenPanel);
  RegisterType(RDateEdit);
  RegisterType(ROkListBox);
  RegisterType(RLargeScrollBar);
{$ENDIF}
end;

end.
