{$I Define.Inc}
unit ibase;

interface

uses Windows, IBTypes;

const
  ISC_TRUE = 1;
  ISC_FALSE = 0;
  DSQL_close = 1;
  DSQL_drop = 2;
  IBASE_DLL = 'gds32.dll';


type
  {*********************************}
  {** InterBase Handle Definitions *}
  {*********************************}
  TISC_ATT_HANDLE               = Pointer;
  PISC_ATT_HANDLE               = ^TISC_ATT_HANDLE;
  TISC_BLOB_HANDLE              = Pointer;
  PISC_BLOB_HANDLE              = ^TISC_BLOB_HANDLE;
  TISC_DB_HANDLE                = Pointer;
  PISC_DB_HANDLE                = ^TISC_DB_HANDLE;
  TISC_FORM_HANDLE              = Pointer;
  PISC_FORM_HANDLE              = ^TISC_FORM_HANDLE;
  TISC_REQ_HANDLE               = Pointer;
  PISC_REQ_HANDLE               = ^TISC_REQ_HANDLE;
  TISC_STMT_HANDLE              = Pointer;
  PISC_STMT_HANDLE              = ^TISC_STMT_HANDLE;
  TISC_SVC_HANDLE               = Pointer;
  PISC_SVC_HANDLE               = ^TISC_SVC_HANDLE;
  TISC_TR_HANDLE                = Pointer;
  PISC_TR_HANDLE                = ^TISC_TR_HANDLE;
  TISC_WIN_HANDLE               = Pointer;
  PISC_WIN_HANDLE               = ^TISC_WIN_HANDLE;
  TISC_CALLBACK                 = procedure;

  {*******************************************************************}
  {* Blob id structure                                               *}
  {*******************************************************************}
  TGDS_QUAD = record
    gds_quad_high      : ISC_LONG;
    gds_quad_low       : UISC_LONG;
  end;
  TGDS__QUAD           = TGDS_QUAD;
  TISC_QUAD            = TGDS_QUAD;
  PGDS_QUAD            = ^TGDS_QUAD;
  PGDS__QUAD           = ^TGDS__QUAD;
  PISC_QUAD            = ^TISC_QUAD;
  {$define  isc_quad_high       gds_quad_high} // useless
  {$define  isc_quad_low        gds_quad_low}  // useless
  TISC_ARRAY_BOUND = record
    array_bound_lower  : short;
    array_bound_upper  : short;
  end;
  PISC_ARRAY_BOUND     = ^TISC_ARRAY_BOUND;
  TISC_ARRAY_DESC = record
    array_desc_dtype            : UChar;
    array_desc_scale            : Char;
    array_desc_length           : word;
    array_desc_field_name       : array[0..31] of Char;
    array_desc_relation_name    : array[0..31] of Char;
    array_desc_dimensions       : word;
    array_desc_flags            : word;
    array_desc_bounds           : array[0..15] of TISC_ARRAY_BOUND;
  end; // TISC_ARRAY_DESC
  PISC_ARRAY_DESC = ^TISC_ARRAY_DESC;

  TISC_BLOB_DESC = record
    blob_desc_subtype           : Short;
    blob_desc_charset           : Short;
    blob_desc_segment_size      : Short;
    blob_desc_field_name        : array[0..31] of UChar;
    blob_desc_relation_name     : array[0..31] of UChar;
  end; // TISC_BLOB_DESC
  PISC_BLOB_DESC = ^TISC_BLOB_DESC;

  {***************************}
  {* Blob control structure  *}
  {***************************}
  TISC_BLOB_CTL_SOURCE_FUNCTION = function: ISC_STATUS; // ISC_FAR
  PISC_BLOB_CTL                 = ^TISC_BLOB_CTL;        // ISC_FAR
  TISC_BLOB_CTL = record
    {* Source filter *}
    ctl_source                  : TISC_BLOB_CTL_SOURCE_FUNCTION;
    {* Argument to pass to source filter *}
    ctl_source_handle           : PISC_BLOB_CTL;
    ctl_to_sub_type             : Short;        {* Target type *}
    ctl_from_sub_type           : Short;        {* Source type *}
    ctl_buffer_length           : word;       {* Length of buffer *}
    ctl_segment_length          : word;       {* Length of current segment *}
    ctl_bpb_length              : word;       {* Length of blob parameter *}
                                                {* block *}
    ctl_bpb                     : PChar;        {* Address of blob parameter *}
                                                {* block *}
    ctl_buffer                  : PUChar;       {* Address of segment buffer *}
    ctl_max_segment             : ISC_LONG;     {* Length of longest segment *}
    ctl_number_segments         : ISC_LONG;     {* Total number of segments *}
    ctl_total_length            : ISC_LONG;     {* Total length of blob *}
    ctl_status                  : PISC_STATUS;  {* Address of status vector *}
    ctl_data                    : array[0..7] of Int; {* Application specific data *}
  end;

  { Blob stream definitions }
  PBStream = ^TBStream;
  TBStream = record
    BStr_Blob                   : Pointer;        {* Blob handle *}
    BStr_Buffer                 : PChar;        {* Address of buffer *}
    BStr_Ptr                    : PChar;        {* Next character *}
    BStr_Length                 : Short;        {* Length of buffer *}
    BStr_Cnt                    : Short;        {* Characters in buffer *}
    BStr_Mode                   : Char;         {* (mode) ? OUTPUT : INPUT *}
  end;

  { Dynamic SQL definitions }
  PSQLVAR = ^TSQLVAR;
  TSQLVAR = record
    sqltype                     : Short;
    sqllen                      : Short;
    sqldata                     : PChar;
    sqlind                      : PWord;
    sqlname_length              : Short;
    sqlname                     : array[0..29] of Char;
  end;

  TSQLDA = record
    sqldaid                     : array[0..7] of Char;
    sqldabc                     : ISC_LONG;
    sqln                        : Short;
    sqld                        : Short;
    sqlvar                      : array[0..0] of TSQLVAR;
  end;
  PSQLDA                         = ^TSQLDA;

  {******************************}
  {* Declare the extended SQLDA *}
  {******************************}
  TXSQLVAR = record
    sqltype                     : Short;     {* datatype of field *}
    sqlscale                    : Short;     {* scale factor *}
    sqlsubtype                  : Short;     {* datatype subtype - BLOBs *}
                                             {* & text types only *}
    sqllen                      : Short;     {* length of data area *}
    sqldata                     : PChar;     {* address of data *}
    sqlind                      : PWord;    {* address of indicator *}
                                             {* variable *}
    sqlname_length              : Short;     {* length of sqlname field *}
    {* name of field, name length + space for NULL *}
    sqlname                     : array[0..31] of Char;
    relname_length              : Short;     {* length of relation name *}
    {* field's relation name + space for NULL *}
    relname                     : array[0..31] of Char;
    ownname_length              : Short;     {* length of owner name *}
    {* relation's owner name + space for NULL *}
    ownname                     : array[0..31] of Char;
    aliasname_length            : Short;     {* length of alias name *}
    {* relation's alias name + space for NULL *}
    aliasname                   : array[0..31] of Char;
  end;  // TXSQLVAR
  PXSQLVAR                      = ^TXSQLVAR;

  TXSQLDA = record
    version                     : Short;     {* version of this XSQLDA *}
    {* XSQLDA name field *}
    sqldaid                     : array[0..7] of Char;
    sqldabc                     : ISC_LONG;  {* length in bytes of SQLDA *}
    sqln                        : Short;     {* number of fields allocated *}
    sqld                        : Short;     {* actual number of fields *}
    {* first field address *}
    sqlvar                      : array[0..0] of TXSQLVAR;
  end; // TXSQLDA
  PXSQLDA                       = ^TXSQLDA;

{******************************************************}
{* This record type is for passing arguments to       *}
{* isc_start_transaction (See docs)                   *}
{* I have left this example structure because of the  *}
{* docs on isc_start_transaction, but all examples    *}
{* point to the "correct?" ISC_TEB structure which is *}
{* documented in examples for isc_start_multiple      *}
{******************************************************}
  TISC_START_TRANS = record
    db_handle      : PISC_DB_HANDLE;
    tpb_length     : word;   // Should it be long?
    tpb_address    : PChar;
  end;

{******************************************************}
{* This record type is for passing arguments to       *}
{* isc_start_multiple (see docs)                      *}
{******************************************************}
  TISC_TEB = record
    db_handle      : PISC_DB_HANDLE;
    tpb_length     : int;
    tpb_address    : PChar;
  end;
  PISC_TEB = ^TISC_TEB;
  TISC_TEB_ARRAY = array[0..0] of TISC_TEB;
  PISC_TEB_ARRAY = ^TISC_TEB_ARRAY;

{***************************}
{* OSRI database functions *}
{***************************}

function isc_attach_database    (status_vector            : PISC_STATUS;
                                 db_name_length           : Short;
                                 db_name                  : PChar;
                                 db_handle                : PISC_DB_HANDLE;
                                 parm_buffer_length       : Short;
                                 parm_buffer              : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_array_gen_sdl      (status_vector            : PISC_STATUS;
                                 isc_array_desc           : PISC_ARRAY_DESC;
                                 isc_arg3                 : Pword;
                                 isc_arg4                 : PChar;
                                 isc_arg5                 : Pword): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_array_get_slice    (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 trans_handle             : PISC_TR_HANDLE;
                                 array_id                 : PISC_QUAD;
                                 descriptor               : PISC_ARRAY_DESC;
                                 dest_array               : Pointer;
                                 slice_length             : ISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_array_lookup_bounds(status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 trans_handle             : PISC_TR_HANDLE;
                                 table_name,
                                 column_name              : PChar;
                                 descriptor               : PISC_ARRAY_DESC): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_array_lookup_desc  (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 trans_handle             : PISC_TR_HANDLE;
                                 table_name,
                                 column_name              : PChar;
                                 descriptor               : PISC_ARRAY_DESC): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_array_set_desc     (status_vector            : PISC_STATUS;
                                 table_name               : PChar;
                                 column_name              : PChar;
                                 sql_dtype,
                                 sql_length,
                                 sql_dimensions           : Pword;
                                 descriptor               : PISC_ARRAY_DESC): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_array_put_slice    (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 trans_handle             : PISC_TR_HANDLE;
                                 array_id                 : PISC_QUAD;
                                 descriptor               : PISC_ARRAY_DESC;
                                 source_array             : Pointer;
                                 slice_length             : PISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

procedure isc_blob_default_desc (descriptor               : PISC_BLOB_DESC;
                                 table_name               : PUChar;
                                 column_name              : PUChar);
                                stdcall; external IBASE_DLL;

function isc_blob_gen_bpb       (status_vector            : PISC_STATUS;
                                 to_descriptor,
                                 from_descriptor          : PISC_BLOB_DESC;
                                 bpb_buffer_length        : word;
                                 bpb_buffer               : PUChar;
                                 bpb_length               : PWord): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_blob_info          (status_vector            : PISC_STATUS;
                                 blob_handle              : PISC_BLOB_HANDLE;
                                 item_list_buffer_length  : Short;
                                 item_list_buffer         : PChar;
                                 result_buffer_length     : Short;
                                 result_buffer            : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_blob_lookup_desc   (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 trans_handle             : PISC_TR_HANDLE;
                                 table_name,
                                 column_name              : PChar;
                                 descriptor               : PISC_BLOB_DESC;
                                 global                   : PUChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_blob_set_desc      (status_vector            : PISC_STATUS;
                                 table_name,
                                 column_name              : PChar;
                                 subtype,
                                 charset,
                                 segment_size             : Short;
                                 descriptor               : PISC_BLOB_DESC): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_cancel_blob        (status_vector            : PISC_STATUS;
                                 blob_handle              : PISC_BLOB_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_cancel_events      (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 event_id                 : PISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_close_blob         (status_vector            : PISC_STATUS;
                                 blob_handle              : PISC_BLOB_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_commit_retaining   (status_vector            : PISC_STATUS;
                                 tran_handle              : PISC_TR_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_commit_transaction (status_vector            : PISC_STATUS;
                                 tran_handle              : PISC_TR_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_create_blob        (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 tran_handle              : PISC_TR_HANDLE;
                                 blob_handle              : PISC_BLOB_HANDLE;
                                 blob_id                  : PISC_QUAD): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_create_blob2       (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 tran_handle              : PISC_TR_HANDLE;
                                 blob_handle              : PISC_BLOB_HANDLE;
                                 blob_id                  : PISC_QUAD;
                                 bpb_length               : Short;
                                 bpb_address              : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_create_database    (status_vector            : PISC_STATUS;
                                 isc_arg2                 : Short;
                                 isc_arg3                 : PChar;
                                 db_handle                : PISC_DB_HANDLE;
                                 isc_arg5                 : Short;
                                 isc_arg6                 : PChar;
                                 isc_arg7                 : Short): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_database_info      (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 item_list_buffer_length  : Short;
                                 item_list_buffer         : PChar;
                                 result_buffer_length     : Short;
                                 result_buffer            : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

procedure isc_decode_date       (ib_date: PISC_QUAD;
                                 tm_date: PCTimeStructure);
                                stdcall; external IBASE_DLL;

function isc_detach_database    (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_drop_database      (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;


{* SQLDA_LENGTH is defined in C as a macro, but in Pascal we must defined it
   as a function... *}
function SQLDA_LENGTH(n: Int): Int;

{* XSQLDA_LENGTH is defined in C as a macro, but in Pascal we must defined it
   as a function... *}
function XSQLDA_LENGTH(n: Int): Int;

function isc_dsql_allocate_statement(status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 stmt_handle              : PISC_STMT_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_alloc_statement2(status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 stmt_handle              : PISC_STMT_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_describe      (status_vector            : PISC_STATUS;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 dialect                  : word;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_describe_bind (status_vector            : PISC_STATUS;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 dialect                  : PWord;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_exec_immed2   (status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 tran_handle              : PISC_TR_HANDLE;
                                 length                   : PWord;
                                 statement                : PChar;
                                 dialect                  : PWord;
                                 in_xsqlda,
                                 out_xsqlda               : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_execute       (status_vector            : PISC_STATUS;
                                 tran_handle              : PISC_TR_HANDLE;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 dialect                  : PWord;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_execute2      (status_vector            : PISC_STATUS;
                                 tran_handle              : PISC_TR_HANDLE;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 dialect                  : PWord;
                                 in_xsqlda,
                                 out_xsqlda               : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_execute_immediate(status_vector            : PISC_STATUS;
                                 db_handle                : PISC_DB_HANDLE;
                                 tran_handle              : PISC_TR_HANDLE;
                                 length                   : PWord;
                                 statement                : PChar;
                                 dialect                  : PWord;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_fetch         (status_vector            : PISC_STATUS;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 dialect                  : PWord;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{$IFDEF SCROLLABLE_CURSORS}
function isc_dsql_fetch2        (status_vector            : PISC_STATUS;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 dialect                  : UShort;
                                 xsqlda                   : PXSQLDA;
                                 isc_arg5                 : UShort;
                                 isc_arg6                 : Long): ISC_STATUS;
                                stdcall; external IBASE_DLL;
{$ENDIF}

function isc_dsql_finish        (db_handle                : PISC_DB_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_free_statement(status_vector            : PISC_STATUS;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 options                  : PWord): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_insert        (status_vector            : PISC_STATUS;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 arg3                     : PWord;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_prepare       (status_vector            : PISC_STATUS;
                                 tran_handle              : PISC_TR_HANDLE;
                                 stmt_handle              : PISC_STMT_HANDLE;
                                 length                   : PWord;
                                 statement                : PChar;
                                 dialect                  : PWord;
                                 xsqlda                   : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_set_cursor_name(status_vector            : PISC_STATUS;
                                 stmt_handle               : PISC_STMT_HANDLE;
                                 cursor_name               : PChar;
                                 _type                     : Word): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_sql_info      (status_vector             : PISC_STATUS;
                                 stmt_handle               : PISC_STMT_HANDLE;
                                 item_length               : Word; // doc says unsigned, header says signed?
                                 items                     : PChar;
                                 buffer_length             : Word; // doc says unsigned, header says signed?
                                 buffer                    : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

procedure isc_encode_date       (tm_date                    : PCTimeStructure;
                                 ib_date                    : PISC_QUAD);
                                stdcall; external IBASE_DLL;

function  isc_event_block       (event_buffer               : PPChar;
                                 result_buffer              : PPChar;
                                 id_count                   : word;
                                 event_list                 : array of PChar): ISC_LONG;
                                cdecl; external IBASE_DLL;

procedure isc_event_counts      (status_vector             : PISC_STATUS;
                                 buffer_length             : Short;
                                 event_buffer              : PChar;
                                 result_buffer             : PChar);
                                stdcall; external IBASE_DLL;

procedure isc_expand_dpb        (dpb                       : PPChar;
                                 dpb_length                : Pword;
                                 item_list                 : array of Pointer);
                                cdecl; external IBASE_DLL;

function isc_modify_dpb         (dpb                       : PPChar;
                                 isc_arg2,
                                 isc_arg3                  : Pword;
                                 isc_arg4                  : word;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : Short): Int;
                                stdcall; external IBASE_DLL;

function isc_free               (isc_arg1                  : PChar): ISC_LONG;
                                stdcall; external IBASE_DLL;

function isc_get_segment        (status_vector             : PISC_STATUS;
                                 blob_handle               : PISC_BLOB_HANDLE;
                                 actual_seg_length         : Pword;
                                 seg_buffer_length         : word;
                                 seg_buffer                : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_get_slice          (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : PISC_QUAD;
                                 isc_arg5                  : Short;
                                 isc_arg6                  : PChar;
                                 isc_arg7                  : Short;
                                 isc_arg8                  : PISC_LONG;
                                 isc_arg9                  : ISC_LONG;
                                 isc_arg10                 : Pointer;
                                 isc_arg11                 : PISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_interprete         (buffer                    : PChar;
                                 status_vector             : PPISC_STATUS): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_open_blob          (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 blob_handle               : PISC_BLOB_HANDLE;
                                 blob_id                   : PISC_QUAD): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_open_blob2         (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 blob_handle               : PISC_BLOB_HANDLE;
                                 blob_id                   : PISC_QUAD;
                                 bpb_length                : Short;
                                 bpb_buffer                : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_prepare_transaction2(status_vector            : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 msg_length                : Short;
                                 msg                       : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

procedure isc_print_sqlerror    (sqlcode                   : Short;
                                 status_vector             : PISC_STATUS);
                                stdcall; external IBASE_DLL;

function isc_print_status       (status_vector             : PISC_STATUS): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_put_segment        (status_vector             : PISC_STATUS;
                                 blob_handle               : PISC_BLOB_HANDLE;
                                 seg_buffer_len            : word;
                                 seg_buffer                : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_put_slice          (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : PISC_QUAD;
                                 isc_arg5                  : Short;
                                 isc_arg6                  : PChar;
                                 isc_arg7                  : Short;
                                 isc_arg8                  : PISC_LONG;
                                 isc_arg9                  : ISC_LONG;
                                 isc_arg10                 : Pointer): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_que_events         (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 event_id                  : PISC_LONG;
                                 length                    : Short;
                                 event_buffer              : PChar;
                                 event_function            : TISC_CALLBACK;
                                 event_function_arg        : Pointer): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_rollback_transaction(status_vector            : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_start_multiple     (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 db_handle_count           : Short;
                                 teb_vector_address        : PISC_TEB): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_start_transaction  (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 db_handle_count           : Short;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tpb_length                : word;
                                 tpb_address               : PChar): ISC_STATUS;
                                cdecl; external IBASE_DLL;

function isc_sqlcode            (status_vector             : PISC_STATUS): ISC_LONG;
                                stdcall; external IBASE_DLL;


procedure isc_sql_interprete    (sqlcode                   : Short;
                                 buffer                    : PChar;
                                 buffer_length             : Short);
                                stdcall; external IBASE_DLL;

function isc_transaction_info   (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 item_list_buffer_length   : Short;
                                 item_list_buffer          : PChar;
                                 result_buffer_length      : Short;
                                 result_buffer             : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;
(*
function isc_transact_request   (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : PChar;
                                 isc_arg8                  : UShort;
                                 isc_arg9                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_vax_integer        (buffer                    : PChar;
                                 length                    : Short): ISC_LONG;
                                stdcall; external IBASE_DLL;


type
  TUserSecData = record
    sec_flags: Short;                {* which fields are specified *}
    uid: Int;                        {* the user's id *}
    gid: int;                        {* the user's group id *}
    protocol: Int;                   {* protocol to use for connection *}
    server: PChar;                   {* server to administer *}
    user_name: PChar;                {* the user's name *}
    password: PChar;                 {* the user's password *}
    group_name: PChar;               {* the group name *}
    first_name: PChar;               {* the user's first name *}
    middle_name: PChar;              {* the user's middle name *}
    last_name: PChar;                {* the user's last name *}
    dba_user_name: PChar;            {* the dba user name *}
    dba_password: PChar;             {* the dba password *}
  end;
  PUserSecData = ^TUserSecData;

function isc_add_user           (status_vector             : PISC_STATUS;
                                 user_sec_data             : PUserSecData): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_delete_user        (status_vector             : PISC_STATUS;
                                 user_sec_data             : PUserSecData): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_modify_user        (status_vector             : PISC_STATUS;
                                 user_sec_data             : PUserSecData): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{**********************************}
{*  Other OSRI functions          *}
{**********************************}

function isc_compile_request    (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : Short;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_compile_request2   (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : Short;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_ddl                (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : Short;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_prepare_transaction(status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;


function Isc_Receive( Status_Vector:PISC_STATUS; request_handle:PISC_REQ_HANDLE;
         isc_arg3, isc_arg4:Short; isc_arg5:PVoid;
         isc_arg6:Short): ISC_STATUS; external IBASE_DLL name 'isc_receive';

function isc_reconnect_transaction(status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : Short;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_release_request    (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_request_info       (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg3                  : Short;
                                 isc_arg4                  : Short;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : Short;
                                 isc_arg7                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_seek_blob          (status_vector             : PISC_STATUS;
                                 blob_handle               : PISC_BLOB_HANDLE;
                                 isc_arg3                  : Short;
                                 isc_arg4                  : ISC_LONG;
                                 isc_arg5                  : PISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_send               (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg3,
                                 isc_arg4                  : Short;
                                 isc_arg5                  : PVoid;
                                 isc_arg6                  : Short): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_start_and_send     (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4,
                                 isc_arg5                  : Short;
                                 isc_arg6                  : PVoid;
                                 isc_arg7                  : Short): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_start_request      (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : Short): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_unwind_request     (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : Short): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_wait_for_event     (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 length                    : Short;
                                 event_buffer,
                                 result_buffer             : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{*****************************}
{* Other Sql functions       *}
{*****************************}

function isc_close              (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_declare            (status_vector             : PISC_STATUS;
                                 isc_arg2,
                                 isc_arg3                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_describe           (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : PSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_describe_bind      (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : PSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_execute            (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : PSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_execute_immediate  (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : PShort;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_fetch              (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : PSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_open               (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : PSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_prepare            (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : PShort;
                                 isc_arg6                  : PChar;
                                 isc_arg7                  : PSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{*************************************}
{* Other Dynamic sql functions       *}
{*************************************}

function isc_dsql_execute_m     (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 statement_handle          : PISC_STMT_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_execute2_m    (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 statement_handle          : PISC_STMT_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PChar;
                                 isc_arg9                  : UShort;
                                 isc_arg10                 : PChar;
                                 isc_arg11                 : UShort;
                                 isc_arg12                 : UShort;
                                 isc_arg13                 : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_execute_immediate_m(status_vector        : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PChar;
                                 isc_arg9                  : UShort;
                                 isc_arg10                 : UShort;
                                 isc_arg11                 : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_exec_immed3_m (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PChar;
                                 isc_arg9                  : UShort;
                                 isc_arg10                 : UShort;
                                 isc_arg11                 : PChar;
                                 isc_arg12                 : UShort;
                                 isc_arg13                 : PChar;
                                 isc_arg14                 : UShort;
                                 isc_arg15                 : UShort;
                                 isc_arg16                 : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_fetch_m       (status_vector             : PISC_STATUS;
                                 statement_handle          : PISC_STMT_HANDLE;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : UShort;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{$IFDEF SCROLLABLE_CURSORS}
function isc_dsql_fetch2_m      (status_vector             : PISC_STATUS;
                                 statement_handle          : PISC_STMT_HANDLE;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : UShort;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : PChar;
                                 isc_arg8                  : UShort;
                                 isc_arg9                  : Long): ISC_STATUS;
                                stdcall; external IBASE_DLL;
{$ENDIF}

function isc_dsql_insert_m      (status_vector             : PISC_STATUS;
                                 statement_handle          : PISC_STMT_HANDLE;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : UShort;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_prepare_m     (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 statement_handle          : PISC_STMT_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PChar;
                                 isc_arg9                  : UShort;
                                 isc_arg10                 : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_dsql_release       (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_close   (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_declare (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_describe(status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_describe_bind(status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_execute (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_execute2(status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PXSQLDA;
                                 isc_arg6                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_execute_immed(status_vector        : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : UShort;
                                 isc_arg7                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_fetch   (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{$IFDEF SCROLLABLE_CURSORS}
function isc_embed_dsql_fetch2 (status_vector             : PISC_STATUS;
                                isc_arg2                  : PChar;
                                isc_arg3                  : UShort;
                                isc_arg4                  : PXSQLDA;
                                isc_arg5                  : UShort;
                                isc_arg6                  : Long): ISC_STATUS;
                                stdcall; external IBASE_DLL;
{$ENDIF}

function isc_embed_dsql_open    (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_open2   (status_vector             : PISC_STATUS;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : UShort;
                                 isc_arg5                  : PXSQLDA;
                                 isc_arg6                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_insert  (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_prepare (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : UShort;
                                 isc_arg6                  : PChar;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PXSQLDA): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_embed_dsql_release (status_vector             : PISC_STATUS;
                                 isc_arg2                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{******************************}
{* Other Blob functions       *}
{******************************}

{* getb, putb, putbx are all defined in C as macros. We pascal folk must
   use functions and procedures to do our dirty work.... *}
function getb                   (p: PBStream): Char;
function putb                   (x: Char; p: PBStream): Int;
function putbx                  (x: Char; p: PBStream): Int;

function BLOB_open              (blob_handle               : TISC_BLOB_HANDLE;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : int): PBStream;
                                stdcall; external IBASE_DLL;

function BLOB_put               (isc_arg1                  : char;
                                 isc_arg2                  : PBStream): Int;
                                stdcall; external IBASE_DLL;

function BLOB_close             (isc_arg1                  : PBStream): Int;
                                stdcall; external IBASE_DLL;

function BLOB_get               (isc_arg1                  : PBStream): Int;
                                stdcall; external IBASE_DLL;

function BLOB_display           (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar): Int;
                                stdcall; external IBASE_DLL;

function BLOB_dump              (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar): Int;
                                stdcall; external IBASE_DLL;

function BLOB_edit              (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar): Int;
                                stdcall; external IBASE_DLL;

function BLOB_load              (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar): Int;
                                stdcall; external IBASE_DLL;

function BLOB_text_dump         (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar): Int;
                                stdcall; external IBASE_DLL;

function BLOB_text_load         (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar): Int;
                                stdcall; external IBASE_DLL;
{BSTREAM     ISC_FAR * ISC_EXPORT Bopen (ISC_QUAD ISC_FAR *, 
                                    isc_db_handle, 
                                    isc_tr_handle,  
                                    char ISC_FAR };

BSTREAM     ISC_FAR * ISC_EXPORT Bopen2 (ISC_QUAD ISC_FAR *, 
                                     isc_db_handle,
                                     isc_tr_handle,  
                                     char ISC_FAR *,
                                     unsigned short);}


{function BOpen( Isc_Arg1:PIsc_Quad; db_handle:TISC_DB_HANDLE;
                tran_handle:TISC_TR_HANDLE;
                isc_arg4:PChar): Int; external IBASE_DLL name 'Bopen';

function Bopen2                 (isc_arg1                  : PISC_QUAD;
                                 db_handle                 : TISC_DB_HANDLE;
                                 tran_handle               : TISC_TR_HANDLE;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : UShort): PBStream;
                                stdcall; external IBASE_DLL;}

{******************************}
{* Other Misc functions       *}
{******************************}

function isc_ftof               (isc_arg1                  : PChar;
                                 isc_arg2                  : UShort;
                                 isc_arg3                  : PChar;
                                 isc_arg4                  : UShort): ISC_LONG;
                                stdcall; external IBASE_DLL;

function isc_print_blr          (isc_arg1                  : PChar;
                                 isc_arg2                  : TISC_CALLBACK;
                                 isc_arg3                  : PVoid;
                                 isc_arg4                  : Short): ISC_STATUS;
                                stdcall; external IBASE_DLL;

procedure isc_set_debug         (isc_arg1                  : Int);
                                stdcall; external IBASE_DLL;

procedure isc_qtoq              (isc_arg1                  : PISC_QUAD;
                                 isc_arg2                  : PISC_QUAD);
                                stdcall; external IBASE_DLL;

procedure isc_vtof              (isc_arg1                  : PChar;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : UShort);
                                stdcall; external IBASE_DLL;

procedure isc_vtov              (isc_arg1                  : PChar;
                                 isc_arg2                  : PChar;
                                 isc_arg3                  : Short);
                                stdcall; external IBASE_DLL;

function isc_version            (db_handle                 : PISC_DB_HANDLE;
                                 isc_arg2                  : TISC_CALLBACK;
                                 isc_arg3                  : PVoid): Int;
                                stdcall; external IBASE_DLL;

{function isc_reset_fpe          (isc_arg1                  : UShort): ISC_LONG;
                                stdcall; external IBASE_DLL;}

{*****************************************}
{* Service manager functions             *}
{*****************************************}

function isc_attach_service     (status_vector             : PISC_STATUS;
                                 isc_arg2                  : UShort;
                                 isc_arg3                  : PChar;
                                 service_handle            : PISC_SVC_HANDLE;
                                 isc_arg5                  : UShort;
                                 isc_arg6                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_detach_service     (status_vector             : PISC_STATUS;
                                 service_handle            : PISC_SVC_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_query_service      (status_vector             : PISC_STATUS;
                                 service_handle            : PISC_SVC_HANDLE;
                                 isc_arg3                  : UShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : UShort;
                                 isc_arg6                  : PChar;
                                 isc_arg7                  : UShort;
                                 isc_arg8                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

{*******************************}
{* Forms functions             *}
{*******************************}

{function isc_compile_map        (status_vector             : PISC_STATUS;
                                 form_handle               : PISC_FORM_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : PShort;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_compile_menu       (status_vector             : PISC_STATUS;
                                 form_handle               : PISC_FORM_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : PShort;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_compile_sub_map    (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : PShort;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_create_window      (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE;
                                 isc_arg3                  : PShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : PShort;
                                 isc_arg6                  : PShort): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_delete_window      (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_drive_form         (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 win_handle                : PISC_WIN_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg6                  : PUChar;
                                 isc_arg7                  : PUChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_drive_menu         (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : PShort;
                                 isc_arg5                  : PChar;
                                 isc_arg6                  : PShort;
                                 isc_arg7                  : PChar;
                                 isc_arg8                  : PShort;
                                 isc_arg9                  : PShort;
                                 isc_arg10                 : PChar;
                                 isc_arg11                 : PISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_form_delete        (status_vector             : PISC_STATUS;
                                 form_handle               : PISC_FORM_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_form_fetch         (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg5                  : PUChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_form_insert        (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg5                  : PUChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_get_entree         (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg3                  : PShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : PISC_LONG;
                                 isc_arg6                  : PShort): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_initialize_menu    (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_menu               (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg4                  : PShort;
                                 isc_arg5                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_load_form          (status_vector             : PISC_STATUS;
                                 db_handle                 : PISC_DB_HANDLE;
                                 tran_handle               : PISC_TR_HANDLE;
                                 form_handle               : PISC_FORM_HANDLE;
                                 isc_arg5                  : PShort;
                                 isc_arg6                  : PChar): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_pop_window         (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_put_entree         (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE;
                                 isc_arg3                  : PShort;
                                 isc_arg4                  : PChar;
                                 isc_arg5                  : PISC_LONG): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_reset_form         (status_vector             : PISC_STATUS;
                                 request_handle            : PISC_REQ_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;

function isc_suspend_window     (status_vector             : PISC_STATUS;
                                 win_handle                : PISC_WIN_HANDLE): ISC_STATUS;
                                stdcall; external IBASE_DLL;}
*)
{* Constants!!! *}

implementation

function SQLDA_LENGTH(n: Int): Int;
{  The C-macro reads like this:
   SQLDA_LENGTH(n)         (sizeof (SQLDA) + (n-1) * sizeof (SQLVAR)) }
begin
  result := sizeof(TSQLDA) + ((n - 1) * sizeof(TSQLVAR));
end;


function XSQLDA_LENGTH(n: Int): Int;
{  The C-macro reads like this:
   XSQLDA_LENGTH(n)     (sizeof (XSQLDA) + (n-1) * sizeof (XSQLVAR)) }
begin
  result := SizeOf(TXSQLDA) + ((n - 1) * SizeOf(TXSQLVAR));
end;

function GetB(p: PBStream): Char;
{  The C-macro reads like this:
   getb(p)      (--(p)->bstr_cnt >= 0 ? *(p)->bstr_ptr++ & 0377: BLOB_get (p)) }
begin
{  Dec(P^.BStr_Cnt);
  if (P^.BStr_Cnt >= 0) then
  begin
    GetB := Char(Ord(P^.BStr_Ptr^) and Int(0377));
    Inc(P^.BStr_Ptr);
  end
  else  GetB := Char(BLOB_get(p));}
end;

function PutB(x: Char; p: PBStream): Int;
{  The C-macro reads like this:
   putb(x,p) ((x == '\n' || (!(--(p)->bstr_cnt))) ?      // then
     BLOB_put (x,p) :                                    // else
     ((int) {(p)->bstr_ptr++ = (unsigned) (x)))) }
begin
{  Dec(p^.bstr_cnt);
  if (x = Chr(Ord('n') - Ord('a'))) or (P^.BStr_Cnt = 0) then
     PutB := BLOB_put(x, p)
  else
  begin
    p^.bstr_ptr^ := Char(x);
    PutB := Ord(x);
    Inc(p^.bstr_ptr^);
  end;}
end;

function PutBX(x: Char; p: PBStream): Int;
{  The C-macro reads like this:
   putbx(x,p) ((!(--(p)->bstr_cnt)) ?    // then
     BLOB_put (x,p) :                    // else
     ((int) {(p)->bstr_ptr++ = (unsigned) (x)))) }
begin
{  Dec(p^.bstr_cnt);
  if (p^.bstr_cnt = 0) then PutBX := BLOB_put(x, p)
  else
  begin
    P^.BStr_Ptr^ := Char(x);
    Inc(P^.BStr_Ptr^);
    PutBX := Ord(x);
  end;}
end;

end.


