{$I DEFINE.INC}

unit Ext_Math;
interface
uses Math;

const
{$IFDEF DELPHI32}
   MaxDubleArraySize = 256;
{$ELSE}
   MaxDubleArraySize = 64;
{$ENDIF}

type
  TPoint = record
    X,Y:Double;
  end;

type
  TDoubleMatrix = array [1..MaxDubleArraySize, 1..MaxDubleArraySize] of Double;

type
  TKvadrResult = (kvNoX,kvSingleX,kvDoubleX);
{For calculate cvadrat uravnenie vida  }
{ A*X^2 + B*X + C = 0                   }
{ A,B,C - Free values                   }
{ X1,X2 - reshenie                      }
{ Return value:                         }
{    kvNoX     - no reshen              }
{    kvSingleX - one koren              }
{    kvDoubleX - two koren              }
function Kvadr(A,B,C:double; var X1, X2:double):TKvadrResult;
function PointInZone(var A,Nor:array of TPoint; X,Y:Double):boolean;

{for mul matrix                         }
{ a - left matrix                       }
{ b - right matrix                      }
{ c - return matrix                     }
{ k,l,m - size of matrix's              }
procedure MatrixMul(var A,B,C:TDoubleMatrix; K,L,M:integer);


implementation

function Kvadr(A,B,C:double; var X1, X2:double):TKvadrResult;
var Diskremen:double;
begin
  Diskremen:=Sqr(B)-4*A*C;
  if (Diskremen<0) or (A=0) then
     Kvadr:=kvNoX
  else
  begin
    Diskremen:=Sqrt(Diskremen);
    if Diskremen=0 then Kvadr:=kvSingleX else Kvadr:=kvDoubleX;
    X1:=(-B+Diskremen)/(2*A);
    X2:=(-B-Diskremen)/(2*A);
  end
end;

function PointInZone(var A,Nor:array of TPoint; X,Y:Double):boolean;
var i:word;
begin
  PointInZone:=true;
  for i:=0 to High(A) do
  if ((X-A[i].X)*Nor[i].Y-(Y-A[i].Y)*Nor[i].Y) < -0.003 then
  begin
    PointInZone:=false;
    exit;
  end
end;

procedure MatrixMul(var A,B,C:TDoubleMatrix; K,L,M:integer);
var
  i,j,n:integer;
begin
  FillChar(C, SizeOf(C), 0);
  for i:=1 to k do
      for j:=1 to m do
          for n:=1 to l do
              c[i,j]:=c[i,j]+a[i,n]*b[n,j];
end;

end.
