{$I-,O-,R-}
{$IFDEF VER70}
{$Q-}
{$ENDIF}

unit Extend;

interface

implementation

uses Dos, Shrink
     {$IFDEF DPMI}
     ,WinAPI
     {$ENDIF};

type HandleArray = array[0..254] of byte;        { Room for 255 handles }
     HandleArrayPtr = ^HandleArray;

var DosMemory: pointer;                          { Pointer to memory gained from DOS }
    OldHandleTable: HandleArrayPtr;              { Pointer to original table }
    OldNumHandles: byte;                         { Original number of handles }

procedure ExtendHandles;
  { Install the extended handles interrupt.  No files (other than
    standard handles) should be open when unit starts up. }
  var DontCare: word;
      Regs: Registers;
      TempSelector: word;

  function Linear(P: pointer): longint;
    { Convert a real pointer into a linear address }
    type Split = record
           Ofs: word;
           Seg: word
           end;
    begin
    Linear := (longint(Split(P).Seg) shl 4) + Split(P).Ofs
    end;

  begin
  {$IFNDEF DPMI}                                 { Can't run DOS 2 on a DPMI system }
(*  if lo(DosVersion) = 2
   then
    begin
    GetIntVec($21,OldInt21);                     { Install interrupt handler under DOS 2.x }
    ExtendInit;                                  { Initialize the interrupt handler }
    SetIntVec($21,@ExtendHandler)
    end
   else*)
  {$ENDIF}
    begin
    DosNewShrink(DosMemory,sizeof(HandleArray));
    if DosMemory <> nil then                     { There wasn't enough memory for a handle table, so just quit }
      if (lo(DosVersion)>=4) or (hi(DosVersion)>=30) { Does this DOS version support the handles call? }
       then
        begin
        DosDispose(DosMemory);                   { Free up the DOS memory block so that the next function will succeed }
        fillchar(Regs,sizeof(Regs),0);           { To avoid protected mode problems }
        with Regs do
          begin
          AH := $67;                             { Tell DOS to allow us 255 handles }
          BX := 255;                             { KEEP THIS NUMBER ODD TO AVOID BUG IN SOME VERSIONS OF DOS 3.3!! }
          MsDos(Regs)
          end
        end
       else
        begin
        fillchar(DosMemory^,sizeof(HandleArray),$FF);     { Initialize new handles as unused }
        OldNumHandles := mem[prefixseg:$0032];            { Get old table length }
        mem[prefixseg:$0032] := sizeof(HandleArray);      { Set new table length }
        {$IFDEF DPMI}
        TempSelector := AllocSelector(0);
        DontCare := SetSelectorBase(TempSelector,Linear(pointer(ptr(prefixseg,$0034)^)));
        DontCare := SetSelectorLimit(TempSelector,256);
        OldHandleTable := ptr(TempSelector,0);            { Save address of old table }
        memw[prefixseg:$0034] := GetSelectorBase(seg(DosMemory^)) and $F; { Point to new handle table (offset) }
        memw[prefixseg:$0036] := GetSelectorBase(seg(DosMemory^)) shr 4;  { Point to new handle table (segment) }
        move(OldHandleTable^,DosMemory^,OldNumHandles);   { Copy the current handle table to the new handle table }
        DontCare := FreeSelector(TempSelector)
        {$ELSE}
        OldHandleTable := pointer(ptr(prefixseg,$0034)^); { Save address of old table }
        pointer(meml[prefixseg:$0034]) := DosMemory;      { Point to new handle table }
        move(OldHandleTable^,DosMemory^,OldNumHandles)    { Copy the current handle table to the new handle table }
        {$ENDIF}
        end
    end
  end;

begin
  ExtendHandles                                    { Enable the extra handles }
end.
