unit InetAPI;
interface
uses Classes, WinSock, WinInet;
type
  TFTPClient = Class(TObject)
    constructor Create;
    destructor Destroy;override;
  end;

type
  TConectionStatus = (csOk, csError);
type
  TSocetConnection = class(TObject)
  private
    fStatus:TConectionStatus;
    fWSData:TWSAData;
    fhInet:HINTERNET;
    procedure SetStatus(aStatus:word);
    function GetHostName:string;
  public
    constructor Create;
    destructor Destroy;override;
    property Status:TConectionStatus read fStatus;
    property HostName:string read GetHostName;
    property hInet:HINTERNET read fhInet;
  end;

const
  SocetConnection:TSocetConnection =  nil;
implementation
uses SysUtils;

constructor TSocetConnection.Create;
var wVersionRequired:word;
    S:ShortString;
begin
  inherited Create;
  wVersionRequired:=$0101;
  SetStatus(WSAStartup(wVersionRequired, fWSData));
  S:=ParamStr(0)+#0;
  fhInet:=InternetOpen(@S[1],INTERNET_OPEN_TYPE_DIRECT, nil, nil,
    INTERNET_FLAG_ASYNC);
end;

destructor TSocetConnection.Destroy;
begin
  InternetCloseHandle(hInet);
  WSACleanup;
  inherited Destroy;
  if SocetConnection=@Self then SocetConnection:=nil;
end;

procedure TSocetConnection.SetStatus(aStatus:word);
begin
  if fStatus<>csOk then exit;
  if AStatus=0 then exit;
  fStatus:=csError;
end;

function TSocetConnection.GetHostName:string;
var
  A:array[1..250] of char;
begin
  SetStatus(WinSock.GetHostname(@A, SizeOf(A)));
  if fStatus=csOk then Result:=StrPas(@A)
  else Result:='';
end;

 { TFTPClient }
constructor TFTPClient.Create;
begin
  inherited Create;
end;

destructor TFTPClient.Destroy;
begin
  inherited Destroy;
end;

initialization
  SocetConnection:=TSocetConnection.Create;
finalization
  if SocetConnection<>nil then SocetConnection.Free;
end.
